#include "config.h"
#include <stdio.h>
#include "aalib.h"
#include "aaint.h"

#define NO_BOARDS_X 2
#define NO_BOARDS_Y 3
#define BOARD_LAYOUT {1,2, 1,1, 1,0, 0,0, 0,1, 0,2}

#define NO_BOARDS (NO_BOARDS_X*NO_BOARDS_Y)


static int stdout_init(__AA_CONST struct aa_hardware_params *p,__AA_CONST  void *none, struct aa_hardware_params *dest, void **n)
{
    __AA_CONST static struct aa_hardware_params def={NULL, AA_NORMAL_MASK | AA_EXTENDED};
    *dest=def;
    return 1;
}
static void stdout_uninit(aa_context * c)
{
}
static void stdout_getsize(aa_context * c, int *width, int *height)
{
    *width=64;
    *height=48;
    return;
}

static void stdout_flush(aa_context * c)
{
    const char sizes[]={0, 32, 56, 36, 30, 40, 28, 16, 44, 37, 32, 24, 22, 24, \
     26, 44, 18, 18, 18, 18, 18, 38, 36, 32, 30, 30, 36, 36, 34, 42, 37, 4, 0, \
     18, 12, 38, 41, 36, 43, 8, 24, 24, 21, 20, 9, 8, 8, 20, 36, 27, 32, 31, \
     35, 37, 39, 26, 40, 39, 16, 17, 20, 16, 20, 25, 46, 42, 46, 32, 44, 34, \
     30, 37, 44, 28, 26, 40, 25, 52, 53, 40, 36, 45, 47, 36, 26, 40, 36, 52, \
     36, 28, 30, 26, 20, 26, 12, 8, 8, 33, 38, 24, 38, 31, 30, 42, 36, 23, 30, \
     34, 23, 41, 30, 28, 36, 36, 21, 30, 26, 30, 26, 38, 26, 39, 22, 22, 20, \
     22, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45, 12, 32, 32, 34, 42, 40, 8, 44, \
     41, 34, 36, 12, 37, 34, 16, 38, 9, 33, 6, 34, 36, 10, 9, 40, 35, 34, 28, \
     12, 32, 26, 53, 48, 50, 52, 50, 31, 38, 37, 39, 40, 39, 42, 42, 34, 36, \
     51, 48, 59, 61, 46, 48, 48, 48, 26, 55, 46, 46, 48, 48, 34, 31, 43, 27, \
     39, 43, 45, 41, 31, 30, 29, 32, 37, 36, 39, 41, 25, 29, 44, 38, 36, 40, \
     34, 38, 40, 36, 24, 29, 38, 36, 42, 38, 45, 31};
    int coords[]=BOARD_LAYOUT;
    int b,n,x,y,t,xx,yy;
    char wbuff[512*NO_BOARDS+2];
    
    t=0;
    wbuff[t++]=0x80;
    
    //write dest to device
    for (b=0; b<NO_BOARDS; b++) {
	xx=coords[b*2]*32;
	yy=coords[(b*2)+1]*16;
	for (y=0; y<16; y++) {
	    for (x=0; x<32; x++) {
		wbuff[t++]=(sizes[c->textbuffer[((x+xx)+((y+yy)*(32*NO_BOARDS_X)))]]<<1)&0x7f;
	    }
	}
    }
    write(1,wbuff,t);
}

static void stdout_gotoxy(aa_context * c, int x, int y)
{
}

__AA_CONST struct aa_driver stdout_d =
{
    "stdout", "Standard output driver",
    stdout_init,
    stdout_uninit,
    stdout_getsize,
    NULL,
    NULL,
    stdout_gotoxy,
    stdout_flush,
    NULL
};


static void stderr_flush(aa_context * c)
{
    int x, y;
    for (y = 0; y < aa_scrheight(c); y++) {
	for (x = 0; x < aa_scrwidth(c); x++) {
	    putc(c->textbuffer[x + y * aa_scrwidth(c)], stderr);
	}
	putc('\n', stderr);
    }
    putc('', stderr);
    putc('\n', stderr);
    fflush(stderr);
}
__AA_CONST struct aa_driver stderr_d =
{
    "stderr", "Standard error driver",
    stdout_init,
    stdout_uninit,
    stdout_getsize,
    NULL,
    NULL,
    stdout_gotoxy,
    stderr_flush,
    NULL
};
